.286
LOCALS
DSEG Segment 'Data'
     EXTRN OldInt10H:DWORD;
     EXTRN OldInt33H:Dword;
     EXTRN MouseHandler:DWORD;
     EXTRN Visibility:Byte;
     EXTRN FixThisMode:Byte;
     EXTRN AndMask:Byte;
     EXTRN XORMask:Byte;
     EXTRN SaveAttr:Byte;
     EXTRN OldPos:WORD
     EXTRN SegB800:Word
     EXTRN ModeForFix:Byte;
DSEG ENDS
CSEG Segment 'Code'
Public Int33Handler,Int10Handler
Public MyMouseHandler

Assume CS:CSEG,DS:DSEG
Int33Handler PROC FAR
             CMP AX,0CH
             JZ @@SetPointer
             CMP AX,0
             JZ @@Reinit
             CMP FixThisMode,0
             JZ @@Exit
             CMP AX,1
             JZ @@Show
             CMP AX,2
             JZ @@Hide
@@Exit:      JMP DWORD PTR OldInt33H
@@Show:      INC Visibility
             Cmp Visibility,0
             JL @@AllDone
             PUSH AX
             PUSH BX
             PUSH CX
             PUSH DX
             PUSH ES
             MOV DX,OldPos
             CALL CalcOffset
             MOV AL,ES:[BX]
             MOV SaveAttr,AL
             AND AL,AndMask
             XOR AL,XORMask
             MOV ES:[BX],AL
             POP ES
             POP DX
             POP CX
             POP BX
             POP AX
@@AllDone:   IRET
@@Hide:      DEC Visibility
             Cmp Visibility,-1
             JNE @@AllDone
             PUSH AX
             PUSH BX
             PUSH CX
             PUSH DX
             PUSH ES
             MOV DX,OldPos
             CALL CalcOffset
             MOV AL,SaveAttr
             MOV ES:[BX],AL
             POP ES
             POP DX
             POP CX
             POP BX
             POP AX
             IRET
@@SetPointer:Cmp CX,0
             JZ @@DisableHandler
             MOV Word Ptr MouseHandler[0],DX
             MOV Word Ptr MouseHandler[2],ES
             IRET
@@DisableHandler:SUB CX,CX
             MOV Word Ptr MouseHandler[0],CX
             MOV Word Ptr MouseHandler[2],CX
             IRET
@@ReInit:    STI
             PUSHF
             Call DWORD PTR OldInt33H
             PUSH AX
             MOV AX,0CH
             MOV CX,0FFFFH
             MOV DX,Offset MyMouseHandler
             PUSH CS
             POP ES
             PUSHF
             Call DWORD PTR OldInt33H
             POP AX
             MOV Visibility,-1
             IRET
Int33Handler ENDP
MyMouseHandler PROC FAR
             PUSH AX
             MOV AX,DSEG
             MOV DS,AX
             POP AX
             CMP FixThisMode,0
             JZ @@CallUserHandler
             TEST AX,1
             JZ @@CallUserHandler
             PUSH AX
             PUSH BX
             PUSH CX
             PUSH DX
             SHR CX,3
             SHR DX,3
             MOV DH,CL
             CMP Visibility,0
             JL @@NoDraw
             PUSH DX
             MOV DX,OldPos
             CALL CalcOffset
             MOV AL,SaveAttr
             MOV ES:[BX],AL
             POP DX
@@NoDraw:    MOV OldPos,DX
             Call CalcOffset
             MOV AL,ES:[BX]
             MOV SaveAttr,AL
             AND AL,AndMask
             XOR Al,XORMask
             MOV ES:[BX],AL
             POP DX
             POP CX
             POP BX
             POP AX
@@CallUserHandler:
             PUSH AX
             MOV AX,Word Ptr MouseHandler[0]
             OR AX,Word Ptr MouseHandler[0]
             POP AX
             JZ @@NoUserHandler
             JMP DWORD PTR MouseHandler
@@NoUserHandler:RET
MyMouseHandler ENDP
CalcOffset Proc Near
             MOV AL,132
             MUL DL
             MOV DL,DH
             SUB DH,DH
             ADD AX,DX
             SHL AX,1
             INC AX
             MOV BX,AX
             MOV ES,SegB800
             RET
CalcOffset Endp
Int10Handler PROC FAR
              PUSH DS
              PUSH AX
              MOV AX,DSEG
              MOV DS,AX
              POP AX
              CMP AH,0
              JNZ @@CallOldHandler
              CMP AL,ModeForFix
              JZ @@EnableFix
              MOV FixThisMode,0
              JMP SHORT @@CallOldHandler
@@EnableFix:  MOV FixThisMode,1
@@CallOldHandler:PUSHF
                 CALL DWORD PTR OldInt10H
                 POP DS
                 IRET
Int10Handler ENDP
CSEG ENDS
END
